'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface ICustomers
		
	
		Property CustomerID() As String
		Property CompanyName() As String
		Property ContactName() As String
		Property ContactTitle() As String
		Property Address() As String
		Property City() As String
		Property Attrib_Region() As String
		Property PostalCode() As String
		Property Country() As String
		Property Phone() As String
		Property Fax() As String
		Property Orders() As OrdersCollection
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class Customers 
		        Inherits PersistentObject
				Implements ICustomers, IComparable 
	
		Private _Orders As OrdersCollection = Nothing
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>CustomerID</c> attribute value.
		' </summary>
		' <value>The <c>CustomerID</c> attribute value.</value>
        Public Property CustomerID() As String _
            Implements ICustomers.CustomerID
			Get
                If (Not me("CustomerID").Null) Then
                    Return CType(me("CustomerID").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("CustomerID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>CompanyName</c> attribute value.
		' </summary>
		' <value>The <c>CompanyName</c> attribute value.</value>
        Public Property CompanyName() As String _
            Implements ICustomers.CompanyName
			Get
                If (Not me("CompanyName").Null) Then
                    Return CType(me("CompanyName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("CompanyName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ContactName</c> attribute value.
		' </summary>
		' <value>The <c>ContactName</c> attribute value.</value>
        Public Property ContactName() As String _
            Implements ICustomers.ContactName
			Get
                If (Not me("ContactName").Null) Then
                    Return CType(me("ContactName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ContactName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ContactTitle</c> attribute value.
		' </summary>
		' <value>The <c>ContactTitle</c> attribute value.</value>
        Public Property ContactTitle() As String _
            Implements ICustomers.ContactTitle
			Get
                If (Not me("ContactTitle").Null) Then
                    Return CType(me("ContactTitle").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("ContactTitle").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Address</c> attribute value.
		' </summary>
		' <value>The <c>Address</c> attribute value.</value>
        Public Property Address() As String _
            Implements ICustomers.Address
			Get
                If (Not me("Address").Null) Then
                    Return CType(me("Address").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Address").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>City</c> attribute value.
		' </summary>
		' <value>The <c>City</c> attribute value.</value>
        Public Property City() As String _
            Implements ICustomers.City
			Get
                If (Not me("City").Null) Then
                    Return CType(me("City").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("City").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Attrib_Region</c> attribute value.
		' </summary>
		' <value>The <c>Attrib_Region</c> attribute value.</value>
        Public Property Attrib_Region() As String _
            Implements ICustomers.Attrib_Region
			Get
                If (Not me("Attrib_Region").Null) Then
                    Return CType(me("Attrib_Region").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Attrib_Region").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>PostalCode</c> attribute value.
		' </summary>
		' <value>The <c>PostalCode</c> attribute value.</value>
        Public Property PostalCode() As String _
            Implements ICustomers.PostalCode
			Get
                If (Not me("PostalCode").Null) Then
                    Return CType(me("PostalCode").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("PostalCode").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Country</c> attribute value.
		' </summary>
		' <value>The <c>Country</c> attribute value.</value>
        Public Property Country() As String _
            Implements ICustomers.Country
			Get
                If (Not me("Country").Null) Then
                    Return CType(me("Country").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Country").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Phone</c> attribute value.
		' </summary>
		' <value>The <c>Phone</c> attribute value.</value>
        Public Property Phone() As String _
            Implements ICustomers.Phone
			Get
                If (Not me("Phone").Null) Then
                    Return CType(me("Phone").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Phone").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Fax</c> attribute value.
		' </summary>
		' <value>The <c>Fax</c> attribute value.</value>
        Public Property Fax() As String _
            Implements ICustomers.Fax
			Get
                If (Not me("Fax").Null) Then
                    Return CType(me("Fax").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Fax").Value = Value
			End Set
		End Property
	
		' <summary>
		' Gets or sets the collection of <c>Orders</c> objects.
		' </summary>
		' <value>The <c>OrdersCollection</c> object.</value>
        Public Property Orders() As OrdersCollection _
            Implements ICustomers.Orders
			Get
				Return _Orders
			End Get
			Set(ByVal Value As OrdersCollection)
				_Orders = Value
			End Set
		End Property		
	
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

		Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try
                If TypeOf obj Is Customers Then
                    Dim cmpCustomers As Customers = CType(obj, Customers)
                    If CustomerID.CompareTo(cmpCustomers.CustomerID) = 0 Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If

            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of Customers")

            End Try

		End Function
		Private Function SetupFields()
	
			AddField(New PersistentField("CustomerID", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("CompanyName", True, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("ContactName", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("ContactTitle", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("Address", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("City", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("Attrib_Region", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("PostalCode", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("Country", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("Phone", False, False, TDevFramework.EDataType.eVarchar))
			AddField(New PersistentField("Fax", False, False, TDevFramework.EDataType.eVarchar))
		End Function
		
		public Sub Copy(objInfo As Customers)
			Me.CustomerID = objInfo.CustomerID 
			Me.CompanyName = objInfo.CompanyName 
			Me.ContactName = objInfo.ContactName 
			Me.ContactTitle = objInfo.ContactTitle 
			Me.Address = objInfo.Address 
			Me.City = objInfo.City 
			Me.Attrib_Region = objInfo.Attrib_Region 
			Me.PostalCode = objInfo.PostalCode 
			Me.Country = objInfo.Country 
			Me.Phone = objInfo.Phone 
            Me.Fax = objInfo.Fax
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
		End Sub
	End Class
End Namespace