'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="ProductsFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:01 2005</creation-datetime>
'		<description>
'			Contains VB.NET code ProductsFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

 Namespace NCacheSample

	Public Interface IProductsFactory
        Function Load(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnalbed As Boolean)
        Function Insert(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Update(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Delete(ByRef objInfo As Products, ByVal nDepth As Int32)
        Function Save(ByRef objList As ProductsCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function DeleteColl(ByRef objList As ProductsCollection, ByVal nDepth As Int32)
        'Function ProcessDataSet(ByVal dataSet As DataSet)

        Function getAll(ByVal bCacheEnabled As Boolean) As ProductsCollection
        Function updateQty(ByVal objInfo As Products)
End Interface
	
	''' <summary>
	''' Object <c>Products</c>Factory. Provides implementation.
	''' </summary>
	''' <remarks>
	'''		
	''' </remarks>
	<  ClassInterface(ClassInterfaceType.AutoDual)> _
	    Public Class ProductsFactory
        Inherits DbObject
        Implements IProductsFactory
		' define constants here for either dynamic SQL or stored procedure calls
		
		Private Shared _stQryObject As String 
        Private Shared _stPKQryObject As String

		Private Const USE_STORE_PROC As Boolean = False
		Private Const STD_LOAD_SQL As String = _
						"SELECT" & _ 
						"     a21.[ProductID] as ProductID, a21.[ProductName] as ProductName," & _ 
						"     a21.[SupplierID] as SupplierID, a21.[CategoryID] as CategoryID," & _ 
						"     a21.[QuantityPerUnit] as QuantityPerUnit, a21.[UnitPrice] as UnitPrice," & _ 
						"     a21.[UnitsInStock] as UnitsInStock, a21.[UnitsOnOrder] as UnitsOnOrder," & _ 
						"     a21.[ReorderLevel] as ReorderLevel, a21.[Discontinued] as Discontinued" & _ 
						" FROM" & _ 
						"     [Products] a21" & _ 
						" WHERE" & _ 
						"     [ProductID] = ?" 
		Private Const STD_INSERT_SQL As String = _
						"INSERT INTO [Products]" & _ 
						"    ([ProductName], [SupplierID]" & _ 
						"     , [CategoryID], [QuantityPerUnit]" & _ 
						"     , [UnitPrice], [UnitsInStock]" & _ 
						"     , [UnitsOnOrder], [ReorderLevel]" & _ 
						"     , [Discontinued]) VALUES (?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?)" 
		Private Const STD_DELETE_SQL As String = _
						"DELETE FROM [Products] WHERE [ProductID] = ?" 
		Private Const STD_UPDATE_SQL As String = _
						"UPDATE" & _ 
						"     [Products]" & _ 
						" SET" & _ 
						"     [ProductName] = ?, [SupplierID] = ?," & _ 
						"     [CategoryID] = ?, [QuantityPerUnit] = ?," & _ 
						"     [UnitPrice] = ?, [UnitsInStock] = ?," & _ 
						"     [UnitsOnOrder] = ?, [ReorderLevel] = ?," & _ 
						"     [Discontinued] = ?" & _ 
						" WHERE" & _ 
						"     [ProductID] = ?" 
		Private Const getAll_SQL As String = _
						"SELECT" & _ 
						"     a21.[ProductID] as ProductID, a21.[ProductName] as ProductName," & _ 
						"     a21.[SupplierID] as SupplierID, a21.[CategoryID] as CategoryID," & _ 
						"     a21.[QuantityPerUnit] as QuantityPerUnit, a21.[UnitPrice] as UnitPrice," & _ 
						"     a21.[UnitsInStock] as UnitsInStock, a21.[UnitsOnOrder] as UnitsOnOrder," & _ 
						"     a21.[ReorderLevel] as ReorderLevel, a21.[Discontinued] as Discontinued" & _ 
						" FROM" & _ 
						"     [Products] a21" 
		Private Const updateQty_SQL As String = _
						"UPDATE" & _ 
						"     [Products]" & _ 
						" SET" & _ 
						"     [UnitsInStock] = ?" & _ 
						" WHERE" & _ 
						"     [ProductID] = ?" 
		

		
        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("Products")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub		
		
        	

	Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub	

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub
        
        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub
        Shared Sub New()
            
        End Sub
       

#Region "[Cache Keys]"
        Private Function GetPKQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...
            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If
            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...
            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If
            GetQueryKey = key
        End Function

        Private Sub InvalidateAll()
            NCacheUtil.Remove(GetQueryKey()) '
            NCacheUtil.Remove(GetPKQueryKey()) '
            _stQryObject = Nothing
        End Sub
        Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type And NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then
                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then
                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then

            End If
        End Sub

#End Region


#Region " Standard Methods "


        ' <summary>
        ' 	Load (Standard Load Method [Cache Enabled])
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Products]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>
        Public Function Load(ByRef objInfo As Products, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
        Implements IProductsFactory.Load

            Dim objKey As String
            Dim obj As Object
            objKey = NCacheUtil.GetObjectKey("Products", objInfo.ProductID.ToString())
            Try
                If bCacheEnable Then
                    obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
                    If obj Is Nothing Then ' Cache miss..
                        _Load(objInfo, nDepth, bCacheEnable)
                        Stats.ObjsReadFromDB = 1
                        Stats.ReadTripsToDB = 1
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                        Exit Function
                    End If
                    Stats.ObjsReadFromCache = 1

                    Dim objTemp As Products = CType(obj, Products)
                    objInfo.Copy(objTemp) ' Cache hit..
                    objInfo.Dirty = False
                    objInfo.IsNew = False
                    If nDepth <> 0 Then
                        LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                    End If
                Else
                    _Load(objInfo, nDepth, bCacheEnable)
                    Stats.ObjsReadFromDB = 1
                    Stats.ReadTripsToDB = 1
                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If

                End If
            Catch e As Exception
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Load (Standard Load Method)
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Products]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>


        Private Function _Load(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)

            Try
                Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)

                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))
                ExecuteReader()
                While (Read())
                    FillPersistentObject(objInfo)
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    bRecordsFound = True
                End While
                ReleaseReader()
                If Not bRecordsFound Then
                    Throw New RecordNotFoundException("No record found against given search criteria.")
                End If

                If (nDepth <> 0) Then
                    LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Insert (Standard Insert Method)
        ' </summary>
        ' <remarks>
        ' 	Adds a new record into the <c>[Products]</c> table.
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object to be inserted.</param>
        ' <param name="nDepth">Specifies depth of children should be inserted.</param>

        Public Function Insert(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
   Implements IProductsFactory.Insert
            Try

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()

                Prepare("SELECT @@IDENTITY AS ProductID;", False)
                ExecuteReader()

                If (Read()) Then
                    If (Not IsNull("ProductID")) Then
                        objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
                    End If
                End If
                ReleaseReader()


                If (nDepth <> 0) Then
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.WriteTripsToDB = 1
                objInfo.IsNew = False
                objInfo.Dirty = False

                If bCacheEnable Then
                    Dim objKey As String

                    objKey = NCacheUtil.GetObjectKey("Products", objInfo.ProductID.ToString())
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK Or NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Delete (Standard Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Deletes the record in <c>[Products]</c> table given
        '   by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object used to delete the record.</param>
        ' <param name="nDepth">Specifies depth of children should be deleted.</param>

        Public Function Delete(ByRef objInfo As Products, ByVal nDepth As Int32) _
         Implements IProductsFactory.Delete
            Try

                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)

                If (nDepth <> 0) Then
                End If
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))
                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Products", objInfo.ProductID.ToString())

                NCacheUtil.Remove(objKey) ' Invalidating all PK query Collections and the Related Collection...
                Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Remove all the NonPK/Partial collections

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Update (Standard Update Method)
        ' </summary>
        ' <remarks>
        ' 	Updates the record in <c>[Products]</c> table given
        ' by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object used to update the record.</param>
        ' <param name="nDepth">Specifies depth of children should be updated.</param>

        Public Function Update(ByRef objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements IProductsFactory.Update
            Try
                CheckPrimaryKeyValues(objInfo)

                objInfo.ValidateRequiredFields()
                Prepare(STD_UPDATE_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                ReadPersistentObject(objInfo)
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))

                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1
                objInfo.Dirty = False

                If (nDepth <> 0) Then
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                objInfo.Dirty = False
 

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

#End Region

        Public Function Save(ByRef objList As ProductsCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
            Implements IProductsFactory.Save

            Dim objInfo As Products = Nothing
            Dim count As Integer
            Dim qryColKey As String

            ' Try to get collection of all Parents..
            qryColKey = NCacheUtil.GetQueryKey("Products", "getAll")

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Products)
                Me.Delete(objInfo, nDepth)
            Next count

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                If (objInfo.IsNew) Then
                    Me.Insert(objInfo, nDepth, bCacheEnable)
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    If bCacheEnable Then
                        Stats.WriteTripsToDBWithCache = 1
                        Stats.ObjsWrittenToDBWithCache = 1
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If
                ElseIf (objInfo.Dirty) Then
                        Me.Update(objInfo, nDepth, bCacheEnable)
                        objInfo.Dirty = False
                        If bCacheEnable Then
                            Stats.WriteTripsToDBWithCache = 1
                            Stats.ObjsWrittenToDBWithCache = 1
                            Dim ls As ArrayList = New ArrayList

                            ls.Add(qryColKey)
                            NCacheUtil.Insert(NCacheUtil.GetObjectKey("Products", objInfo.ProductID.ToString()), objInfo, ls, DateTime.Now.AddMinutes(30))
                    Else
                        Stats.WriteTripsToDB = 1
                        Stats.ObjsWrittenToDB = 1
                    End If
                    End If
            Next count

            If bCacheEnable Then

                Dim _product As Products
                Dim cacheKeys As ArrayList = New ArrayList
                
                '_productColl = NCacheUtil.Load(qryColKey)
                cacheKeys = New ArrayList

                For Each _product In objList
                    cacheKeys.Add(NCacheUtil.GetObjectKey("Products", _product.ProductID.ToString()))
                Next

                cacheKeys.Add(GetPKQueryKey())
                NCacheUtil.Insert(qryColKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))

            End If

        End Function


        ' <summary>
        ' 	DeleteColl (Standard Collection Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Performs standard delete on a collection of <c>Products</c> objects.
        ' </remarks>
        ' <param name="objList">The <c>ProductsCollection</c> object.</param>
        ' <param name="nDepth">integer that is passed to each delete operation.</param>		

        Public Function DeleteColl(ByRef objList As ProductsCollection, ByVal nDepth As Int32) _
                  Implements IProductsFactory.DeleteColl

            Dim objInfo As Products = Nothing
            Dim count As Integer

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth)
                End If
            Next count

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Products)
                Me.Delete(objInfo, nDepth)
            Next count

        End Function



#Region " Queries "

        ' <summary>
        ' 	getAll (Query Method)
        ' </summary>
        ' <remarks>
        ' 	
        ' </remarks>
        ' <returns><c>ProductsCollection</c> object containing all the records 
        '	returned in the resultset.</returns>

        Public Function getAll(ByVal bCacheEnable As Boolean) As ProductsCollection _
         Implements IProductsFactory.getAll

            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim obj As Object

            objKey = NCacheUtil.GetQueryKey("Products", "getAll")

            If bCacheEnable Then
                obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, ProductsCollection).Count
                    Return CType(obj, ProductsCollection) ' Return from Cache..
                End If
            End If
            Dim objInfo As Products
            Dim objList As ProductsCollection = New ProductsCollection

            Try

                Prepare(getAll_SQL, USE_STORE_PROC)

                ExecuteReader()

                While (Read())
                    objInfo = New Products
                    If (Not IsNull("ProductID")) Then
                        objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
                    End If
                    If (Not IsNull("ProductName")) Then
                        objInfo.ProductName = Convert.ToString(getValue("ProductName"))
                    End If
                    If (Not IsNull("SupplierID")) Then
                        objInfo.SupplierID = Convert.ToInt32(getValue("SupplierID"))
                    End If
                    If (Not IsNull("CategoryID")) Then
                        objInfo.CategoryID = Convert.ToInt32(getValue("CategoryID"))
                    End If
                    If (Not IsNull("QuantityPerUnit")) Then
                        objInfo.QuantityPerUnit = Convert.ToString(getValue("QuantityPerUnit"))
                    End If
                    If (Not IsNull("UnitPrice")) Then
                        objInfo.UnitPrice = Convert.ToDecimal(getValue("UnitPrice"))
                    End If
                    If (Not IsNull("UnitsInStock")) Then
                        objInfo.UnitsInStock = Convert.ToInt16(getValue("UnitsInStock"))
                    End If
                    If (Not IsNull("UnitsOnOrder")) Then
                        objInfo.UnitsOnOrder = Convert.ToInt16(getValue("UnitsOnOrder"))
                    End If
                    If (Not IsNull("ReorderLevel")) Then
                        objInfo.ReorderLevel = Convert.ToInt16(getValue("ReorderLevel"))
                    End If
                    If (Not IsNull("Discontinued")) Then
                        objInfo.Discontinued = Convert.ToBoolean(getValue("Discontinued"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    objList.Add(objInfo)
                    Stats.ObjsReadFromDB = 1

                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                        Dim key As String
                        key = NCacheUtil.GetObjectKey("Products", objInfo.ProductID.ToString())
                        cacheKeys.Add(key)
                        NCacheUtil.Insert(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If
                End While

                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1
                If bCacheEnable Then
                    Stats.ReadTripsToDBWithCache = 1
                    If cacheKeys.Count > 0 Then
                        cacheKeys.Add(GetPKQueryKey())
                        NCacheUtil.Insert(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                    End If
                End If
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function





#End Region

#Region " Bulk Update Operations "

#End Region

#Region " Bulk Delete Operations "

#End Region

#Region " Custom Insert Operations "

#End Region

#Region " Custom Update Operations "

        ' <summary>
        ' 	updateQty (Custom Update Method)
        ' </summary>
        ' <remarks>
        ' 	<para>Updates partial record in <c>[Products]</c> table given by primary key.</para>
        ' 	<para>
        ' 	
        ' 	</para>
        ' </remarks>
        ' <param name="objInfo">The <c>Products</c> info object used to update the record.</param>	

        Public Function updateQty(ByVal objInfo As Products) _
         Implements IProductsFactory.updateQty

            Try
                CheckPrimaryKeyValues(objInfo)
                Prepare(updateQty_SQL, USE_STORE_PROC)

                AddCmdParameter("@UnitsInStock", TDevFramework.EDataType.eSmallInt, objInfo.UnitsInStock, TDevFramework.EParamDirection.eInput, objInfo.IsNull("UnitsInStock"))
                AddCmdParameter("@ProductID", TDevFramework.EDataType.eInt, objInfo.ProductID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductID"))
                ExecuteNonQuery()


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


#End Region

#Region " Custom Load Operations "

#End Region

#Region " Stored Procedures "

#End Region

#Region " Utility Methods "

        Private Function FillPersistentObject(ByVal objInfo As Products)

            If (Not IsNull("ProductID")) Then
                objInfo.ProductID = Convert.ToInt32(getValue("ProductID"))
            End If
            If (Not IsNull("ProductName")) Then
                objInfo.ProductName = Convert.ToString(getValue("ProductName"))
            End If
            If (Not IsNull("SupplierID")) Then
                objInfo.SupplierID = Convert.ToInt32(getValue("SupplierID"))
            End If
            If (Not IsNull("CategoryID")) Then
                objInfo.CategoryID = Convert.ToInt32(getValue("CategoryID"))
            End If
            If (Not IsNull("QuantityPerUnit")) Then
                objInfo.QuantityPerUnit = Convert.ToString(getValue("QuantityPerUnit"))
            End If
            If (Not IsNull("UnitPrice")) Then
                objInfo.UnitPrice = Convert.ToDecimal(getValue("UnitPrice"))
            End If
            If (Not IsNull("UnitsInStock")) Then
                objInfo.UnitsInStock = Convert.ToInt16(getValue("UnitsInStock"))
            End If
            If (Not IsNull("UnitsOnOrder")) Then
                objInfo.UnitsOnOrder = Convert.ToInt16(getValue("UnitsOnOrder"))
            End If
            If (Not IsNull("ReorderLevel")) Then
                objInfo.ReorderLevel = Convert.ToInt16(getValue("ReorderLevel"))
            End If
            If (Not IsNull("Discontinued")) Then
                objInfo.Discontinued = Convert.ToBoolean(getValue("Discontinued"))
            End If

        End Function

        Private Function ReadPersistentObject(ByVal objInfo As Products)

            AddCmdParameter("@ProductName", TDevFramework.EDataType.eVarchar, objInfo.ProductName, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ProductName"))
            AddCmdParameter("@SupplierID", TDevFramework.EDataType.eInt, objInfo.SupplierID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("SupplierID"))
            AddCmdParameter("@CategoryID", TDevFramework.EDataType.eInt, objInfo.CategoryID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CategoryID"))
            AddCmdParameter("@QuantityPerUnit", TDevFramework.EDataType.eVarchar, objInfo.QuantityPerUnit, TDevFramework.EParamDirection.eInput, objInfo.IsNull("QuantityPerUnit"))
            AddCmdParameter("@UnitPrice", TDevFramework.EDataType.eDecimal, objInfo.UnitPrice, TDevFramework.EParamDirection.eInput, objInfo.IsNull("UnitPrice"))
            AddCmdParameter("@UnitsInStock", TDevFramework.EDataType.eSmallInt, objInfo.UnitsInStock, TDevFramework.EParamDirection.eInput, objInfo.IsNull("UnitsInStock"))
            AddCmdParameter("@UnitsOnOrder", TDevFramework.EDataType.eSmallInt, objInfo.UnitsOnOrder, TDevFramework.EParamDirection.eInput, objInfo.IsNull("UnitsOnOrder"))
            AddCmdParameter("@ReorderLevel", TDevFramework.EDataType.eSmallInt, objInfo.ReorderLevel, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ReorderLevel"))
            AddCmdParameter("@Discontinued", TDevFramework.EDataType.eBoolean, objInfo.Discontinued, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Discontinued"))

        End Function


        Private Function CheckPrimaryKeyValues(ByVal objInfo As Products) As Boolean
            If ((objInfo("ProductID").Null)) Then
                Throw New Exception("Primary key must have some valid value.")
            End If
            Return True

        End Function

#End Region

#Region "LoadChildren Methods"

        Public Function LoadChildren(ByVal objInfo As Products, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        End Function

#End Region

    End Class
End Namespace
