'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


' <fileinfo name="CustomersFactory.vb">
'		<author></author>
'		<creation-datetime>Tue Jun 07 04:35:00 2005</creation-datetime>
'		<description>
'			Contains VB.NET code CustomersFactory.
'		</description>
'		<remarks>
'			Changes to this file will be lost if the code is regenerated.
'		</remarks>
' </fileinfo>
 
Imports System
Imports System.Data
Imports System.Text
Imports System.Globalization
Imports System.Resources
Imports System.Threading
Imports System.Reflection
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework 

Imports System.Data.OleDb

 Namespace NCacheSample

	Public Interface ICustomersFactory
        Function Load(ByRef objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnalbed As Boolean)
        Function Insert(ByVal objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Update(ByVal objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function Delete(ByVal objInfo As Customers, ByVal nDepth As Int32)
        Function Save(ByVal objList As CustomersCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
        Function DeleteColl(ByVal objList As CustomersCollection, ByVal nDepth As Int32)
        'Function ProcessDataSet(ByVal dataSet As DataSet)

        Function getAll(ByVal bCacheEnabled As Boolean) As CustomersCollection
End Interface
	
	''' <summary>
	''' Object <c>Customers</c>Factory. Provides implementation.
	''' </summary>
	''' <remarks>
	'''		
	''' </remarks>
	<  ClassInterface(ClassInterfaceType.AutoDual)> _
	    Public Class CustomersFactory
        Inherits DbObject
        Implements ICustomersFactory
		' define constants here for either dynamic SQL or stored procedure calls
		
		Private Shared _stQryObject As String 
		Private Shared _stPKQryObject As String 
		
		Private Const USE_STORE_PROC As Boolean = False
		Private Const STD_LOAD_SQL As String = _
						"SELECT" & _ 
						"     a12.[CustomerID] as CustomerID, a12.[CompanyName] as CompanyName," & _ 
						"     a12.[ContactName] as ContactName, a12.[ContactTitle] as ContactTitle," & _ 
						"     a12.[Address] as Address, a12.[City] as City," & _ 
						"     a12.[Region] as Attrib_Region, a12.[PostalCode] as PostalCode," & _ 
						"     a12.[Country] as Country, a12.[Phone] as Phone," & _ 
						"     a12.[Fax] as Fax" & _ 
						" FROM" & _ 
						"     [Customers] a12" & _ 
						" WHERE" & _ 
						"     [CustomerID] = ?" 
		Private Const STD_INSERT_SQL As String = _
						"INSERT INTO [Customers]" & _ 
						"    ([CustomerID], [CompanyName]" & _ 
						"     , [ContactName], [ContactTitle]" & _ 
						"     , [Address], [City]" & _ 
						"     , [Region], [PostalCode]" & _ 
						"     , [Country], [Phone]" & _ 
						"     , [Fax]) VALUES (?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?, ?" & _ 
						"     , ?)" 
		Private Const STD_DELETE_SQL As String = _
						"DELETE FROM [Customers] WHERE [CustomerID] = ?" 
		Private Const STD_UPDATE_SQL As String = _
						"UPDATE" & _ 
						"     [Customers]" & _ 
						" SET" & _ 
						"     [CompanyName] = ?, [ContactName] = ?," & _ 
						"     [ContactTitle] = ?, [Address] = ?," & _ 
						"     [City] = ?, [Region] = ?," & _ 
						"     [PostalCode] = ?, [Country] = ?," & _ 
						"     [Phone] = ?, [Fax] = ?" & _ 
						" WHERE" & _ 
						"     [CustomerID] = ?" 
		Private Const getAll_SQL As String = _
						"SELECT" & _ 
						"     a12.[CustomerID] as CustomerID, a12.[ContactName] as ContactName," & _ 
						"     a12.[ContactTitle] as ContactTitle, a12.[Address] as Address," & _ 
						"     a12.[City] as City, a12.[PostalCode] as PostalCode," & _ 
						"     a12.[Country] as Country, a12.[Region] as Attrib_Region," & _ 
						"     a12.[Fax] as Fax, a12.[Phone] as Phone," & _ 
						"     a12.[CompanyName] as CompanyName" & _ 
						" FROM" & _ 
						"     [Customers] a12" 
		

		
        ' second argument to base() is a flag about whether we're using stored procedures
        ' or dynamic SQL; true = storedProc, false = dynamic sql
        'TDevFramework.PropertyFile.CreateInstance("DbConnStr.db").LoadProperty("Customers")
        Public Sub New()
            MyBase.new("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\NorthwindDB\Northwind.mdb;User Id=;Password=;", TDevFramework.EDBProvider.OLEDB)
        End Sub		
		
        	

	Public Sub New(ByVal connectionString As String)
            MyBase.new(connectionString, TDevFramework.EDBProvider.OLEDB)
        End Sub	

        Public Sub New(ByVal connection As TDevFramework.Connection)
            MyBase.new(connection)
        End Sub
        
        Public Sub New(ByVal connection As Object)
            MyBase.new(connection, TDevFramework.EDBProvider.OLEDB)
        End Sub

		#Region "[Cache Keys]"
        Private Function GetPKQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".PKQry" ' A dummy key ...
            If _stPKQryObject = "" Then
                _stPKQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stPKQryObject, Nothing)
            End If
            GetPKQueryKey = key
        End Function
        Private Function GetQueryKey() As String
            Dim key As String
            key = Convert.ToString(Me) + ".NonPKQry" ' A dummy key ...
            If _stQryObject = "" Then
                _stQryObject = "INSTANTIATED"
                NCacheUtil.Store(key, _stQryObject, Nothing)
            End If
            GetQueryKey = key
        End Function
					
		Private Sub InvalidateAll()
            NCacheUtil.Remove(GetQueryKey()) '
            NCacheUtil.Remove(GetPKQueryKey()) '
            _stQryObject = Nothing
        End Sub
		Private Sub Invalidate(ByVal type As NCacheUtil.InvalidateType, ByVal ParamArray relatedKeys As String())
            '_staticObject = "INVALIDATED"
            'NCacheUtil.Insert(GetStaticObjectKey(),_staticObject,Nothing)
            '_staticObject = Nothing'
            If ((type And NCacheUtil.InvalidateType.QueryCollectionPK) = NCacheUtil.InvalidateType.QueryCollectionPK) Then
                If _stPKQryObject <> "" Then
                    NCacheUtil.Remove(GetPKQueryKey())
                    _stPKQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.QueryCollection) = NCacheUtil.InvalidateType.QueryCollection) Then
                If _stQryObject <> "" Then
                    NCacheUtil.Remove(GetQueryKey())
                    _stQryObject = Nothing
                End If
            End If
            If ((type And NCacheUtil.InvalidateType.RelatedCollection) = NCacheUtil.InvalidateType.RelatedCollection) Then
			
            End If
        End Sub
		
		#End Region


		#Region  " Standard Methods "


		' <summary>
		' 	Load (Standard Load Method [Cache Enabled])
		' </summary>
		' <remarks>
		' 	Loads a record from the <c>[Customers]</c> table given by
		' 	the specified primary key.
		' </remarks>
		' <param name="objInfo">The <c>Customers</c> info object containing the primary key.</param>
		' <param name="nDepth">Specifies depth of children should be loaded.</param>
        Public Function Load(ByRef objInfo As Customers, ByVal nDepth As Integer, ByVal bCacheEnable As Boolean) _
  Implements ICustomersFactory.Load

            Dim objKey As String
            Dim obj As Object
            objKey = "Customers." & objInfo.CustomerID
            Try
                If bCacheEnable Then
                    obj = NCacheUtil.Load(objKey) ' Check if the object is in Cache. 
                    If obj Is Nothing Then ' Cache miss..
                        _Load(objInfo, nDepth, bCacheEnable)
                        Stats.ObjsReadFromDBWithCache = 1
                        Stats.ReadTripsToDBWithCache = 1
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                        Exit Function
                    End If
                    Stats.ObjsReadFromCache = 1
                    'objInfo.Copy(CType(obj, Customers)) ' Cache hit..
                    Dim objTemp As Customers = CType(obj, Customers)
                    objInfo.Copy(objTemp) ' Cache hit..

                    If nDepth <> 0 Then
                        LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                    End If

                Else
                    _Load(objInfo, nDepth, bCacheEnable)
                    Stats.ReadTripsToDB = 1
                    Stats.ObjsReadFromDB = 1
                    If bCacheEnable Then
                        NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    End If

                End If
            Catch e As Exception
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Load (Standard Load Method)
        ' </summary>
        ' <remarks>
        ' 	Loads a record from the <c>[Customers]</c> table given by
        ' 	the specified primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Customers</c> info object containing the primary key.</param>
        ' <param name="nDepth">Specifies depth of children should be loaded.</param>


        Private Function _Load(ByRef objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)

            Try
                Dim bRecordsFound As Boolean = False
                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_LOAD_SQL, USE_STORE_PROC)

                AddCmdParameter("@CustomerID", TDevFramework.EDataType.eVarchar, objInfo.CustomerID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CustomerID"))
                ExecuteReader()
                While (Read())
                    FillPersistentObject(objInfo)
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    bRecordsFound = True
                End While
                ReleaseReader()
                If Not bRecordsFound Then
                    Throw New RecordNotFoundException("No record found against given search criteria.")
                End If

                If (nDepth <> 0) Then
                    LoadChildren(objInfo, nDepth - 1, bCacheEnable)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Throw e
            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Insert (Standard Insert Method)
        ' </summary>
        ' <remarks>
        ' 	Adds a new record into the <c>[Customers]</c> table.
        ' </remarks>
        ' <param name="objInfo">The <c>Customers</c> info object to be inserted.</param>
        ' <param name="nDepth">Specifies depth of children should be inserted.</param>

        Public Function Insert(ByVal objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
   Implements ICustomersFactory.Insert
            Try

                Dim objKey As String

                objInfo.ValidateRequiredFields()

                Prepare(STD_INSERT_SQL, USE_STORE_PROC)
                If (nDepth <> 0) Then
                End If
                AddCmdParameter("@CustomerID", TDevFramework.EDataType.eVarchar, objInfo.CustomerID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CustomerID"))

                'Read the persistent object
                ReadPersistentObject(objInfo)
                ExecuteNonQuery()
                ReleaseReader()

                If (nDepth <> 0) Then
                    Dim _OrdersFactory As OrdersFactory = New OrdersFactory(getConnection())
                    _OrdersFactory.Save(objInfo.Orders, nDepth - 1, bCacheEnable, New Customers)
                End If

                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.WriteTripsToDB = 1
                objInfo.IsNew = False
                objInfo.Dirty = False

                If bCacheEnable Then
                    objKey = NCacheUtil.GetObjectKey("Customers", objInfo.CustomerID)
                    NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                    Invalidate(NCacheUtil.InvalidateType.QueryCollectionPK And NCacheUtil.InvalidateType.QueryCollection, Nothing)
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

        ' <summary>
        ' 	Delete (Standard Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Deletes the record in <c>[Customers]</c> table given
        '   by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Customers</c> info object used to delete the record.</param>
        ' <param name="nDepth">Specifies depth of children should be deleted.</param>

        Public Function Delete(ByVal objInfo As Customers, ByVal nDepth As Int32) _
         Implements ICustomersFactory.Delete
            Try

                CheckPrimaryKeyValues(objInfo)
                Prepare(STD_DELETE_SQL, USE_STORE_PROC)

                If (nDepth <> 0) Then
                    Dim _OrdersFactory As OrdersFactory = New OrdersFactory(getConnection())
                    _OrdersFactory.DeleteByCustomers(objInfo.CustomerID)
                End If

                AddCmdParameter("@CustomerID", TDevFramework.EDataType.eVarchar, objInfo.CustomerID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CustomerID"))
                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1


                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Customers", objInfo.CustomerID)

                NCacheUtil.Remove(objKey) ' Invalidating all PK query Collections and the Related Collection...
                Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Remove all the NonPK/Partial collections

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function


        ' <summary>
        ' 	Update (Standard Update Method)
        ' </summary>
        ' <remarks>
        ' 	Updates the record in <c>[Customers]</c> table given
        ' by its primary key.
        ' </remarks>
        ' <param name="objInfo">The <c>Customers</c> info object used to update the record.</param>
        ' <param name="nDepth">Specifies depth of children should be updated.</param>

        Public Function Update(ByVal objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
         Implements ICustomersFactory.Update
            Try

                CheckPrimaryKeyValues(objInfo)

                objInfo.ValidateRequiredFields()
                Prepare(STD_UPDATE_SQL, USE_STORE_PROC)

                If (nDepth <> 0) Then
                End If

                ReadPersistentObject(objInfo)
                AddCmdParameter("@CustomerID", TDevFramework.EDataType.eVarchar, objInfo.CustomerID, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CustomerID"))

                ExecuteNonQuery()
                Stats.WriteTripsToDB = 1
                objInfo.Dirty = False

                If (nDepth <> 0) Then
                    Dim _OrdersFactory As OrdersFactory = New OrdersFactory(getConnection())
                    _OrdersFactory.Save(objInfo.Orders, True, bCacheEnable, New Customers)
                End If
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()

                Dim objKey As String
                objKey = NCacheUtil.GetObjectKey("Customers", objInfo.CustomerID)

                NCacheUtil.Remove(objKey)  ' Invalidating RElated Collection PKQueryCollection...
                Invalidate(NCacheUtil.InvalidateType.QueryCollection, Nothing) ' Invalidating Collection With NO PK
                ' adding the copy of this object in Cache.. 
                NCacheUtil.Store(objKey, objInfo, Nothing, DateTime.Now.AddMinutes(30))

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
        End Function

#End Region
		
		
        Public Function Save(ByVal objList As CustomersCollection, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean) _
                  Implements ICustomersFactory.Save

            Dim objInfo As Customers = Nothing
            Dim count As Integer

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Customers)
                Me.Delete(objInfo, nDepth)
            Next count

            For count = 0 To objList.Count - 1
                objInfo = objList(count)

                If (objInfo.IsNew) Then
                    Me.Insert(objInfo, nDepth, bCacheEnable)
                ElseIf (objInfo.Dirty) Then
                    Me.Update(objInfo, nDepth, bCacheEnable)

                End If

            Next count

        End Function


        ' <summary>
        ' 	DeleteColl (Standard Collection Delete Method)
        ' </summary>
        ' <remarks>
        ' 	Performs standard delete on a collection of <c>Customers</c> objects.
        ' </remarks>
        ' <param name="objList">The <c>CustomersCollection</c> object.</param>
        ' <param name="nDepth">integer that is passed to each delete operation.</param>		

        Public Function DeleteColl(ByVal objList As CustomersCollection, ByVal nDepth As Int32) _
                  Implements ICustomersFactory.DeleteColl

            Dim objInfo As Customers = Nothing
            Dim count As Integer

            For count = 0 To objList.Count - 1
                objInfo = objList(count)
                If (Not objInfo.IsNew) Then
                    Me.Delete(objInfo, nDepth)
                End If
            Next count

            For count = 0 To objList.MarkedDeletedItems.Count - 1
                objInfo = CType(objList.MarkedDeletedItems(count), Customers)
                Me.Delete(objInfo, nDepth)
            Next count

        End Function



#Region " Queries "

        ' <summary>
        ' 	getAll (Query Method)
        ' </summary>
        ' <remarks>
        ' 	Get list of all customers
        ' </remarks>
        ' <returns><c>CustomersCollection</c> object containing all the records 
        '	returned in the resultset.</returns>

        Public Function getAll(ByVal bCacheEnable As Boolean) As CustomersCollection _
         Implements ICustomersFactory.getAll

            Dim objKey As String
            Dim cacheKeys As ArrayList = New ArrayList
            Dim obj As Object

            objKey = "Customers.getAll"
            If bCacheEnable Then
                obj = NCacheUtil.Load(objKey) ' Try to load from Cache...
                If Not obj Is Nothing Then
                    Stats.ObjsReadFromCache = CType(obj, CustomersCollection).Count
                    Return CType(obj, CustomersCollection) ' Return from Cache..
                End If
            End If

            Dim objInfo As Customers
            Dim objList As CustomersCollection = New CustomersCollection

            Try

                Prepare(getAll_SQL, USE_STORE_PROC)

                ExecuteReader()
                While (Read())
                    objInfo = New Customers
                    If (Not IsNull("CustomerID")) Then
                        objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
                    End If
                    If (Not IsNull("ContactName")) Then
                        objInfo.ContactName = Convert.ToString(getValue("ContactName"))
                    End If
                    If (Not IsNull("ContactTitle")) Then
                        objInfo.ContactTitle = Convert.ToString(getValue("ContactTitle"))
                    End If
                    If (Not IsNull("Address")) Then
                        objInfo.Address = Convert.ToString(getValue("Address"))
                    End If
                    If (Not IsNull("City")) Then
                        objInfo.City = Convert.ToString(getValue("City"))
                    End If
                    If (Not IsNull("PostalCode")) Then
                        objInfo.PostalCode = Convert.ToString(getValue("PostalCode"))
                    End If
                    If (Not IsNull("Country")) Then
                        objInfo.Country = Convert.ToString(getValue("Country"))
                    End If
                    If (Not IsNull("Attrib_Region")) Then
                        objInfo.Attrib_Region = Convert.ToString(getValue("Attrib_Region"))
                    End If
                    If (Not IsNull("Fax")) Then
                        objInfo.Fax = Convert.ToString(getValue("Fax"))
                    End If
                    If (Not IsNull("Phone")) Then
                        objInfo.Phone = Convert.ToString(getValue("Phone"))
                    End If
                    If (Not IsNull("CompanyName")) Then
                        objInfo.CompanyName = Convert.ToString(getValue("CompanyName"))
                    End If
                    objInfo.IsNew = False
                    objInfo.Dirty = False
                    objList.Add(objInfo)
                    Stats.ObjsReadFromDB = 1

                    If bCacheEnable Then
                        Stats.ObjsReadFromDBWithCache = 1
                    End If

                    Dim key As String
                    key = "Customers." & objInfo.CustomerID
                    cacheKeys.Add(key)
                    NCacheUtil.Store(key, objInfo, Nothing, DateTime.Now.AddMinutes(30))
                End While


                ReleaseReader()
                SetStatus(EStatus.eSuccess)
                ReleaseCommand()
                Stats.ReadTripsToDB = 1
                If bCacheEnable Then
                    Stats.ReadTripsToDBWithCache = 1
                End If

                If cacheKeys.Count > 0 Then

                    cacheKeys.Add(GetPKQueryKey())
                    NCacheUtil.Store(objKey, objList, cacheKeys, DateTime.Now.AddMinutes(30))
                End If

            Catch e As Exception
                SetStatus(EStatus.eFail)
                ReleaseCommand()
                Throw e
            End Try
            Return objList
        End Function





#End Region

#Region " Bulk Update Operations "

#End Region

#Region " Bulk Delete Operations "

#End Region

#Region " Custom Insert Operations "

#End Region

#Region " Custom Update Operations "

#End Region

#Region " Custom Load Operations "

#End Region

#Region " Stored Procedures "

#End Region

#Region " Utility Methods "

        Private Function FillPersistentObject(ByVal objInfo As Customers)

            If (Not IsNull("CustomerID")) Then
                objInfo.CustomerID = Convert.ToString(getValue("CustomerID"))
            End If
            If (Not IsNull("CompanyName")) Then
                objInfo.CompanyName = Convert.ToString(getValue("CompanyName"))
            End If
            If (Not IsNull("ContactName")) Then
                objInfo.ContactName = Convert.ToString(getValue("ContactName"))
            End If
            If (Not IsNull("ContactTitle")) Then
                objInfo.ContactTitle = Convert.ToString(getValue("ContactTitle"))
            End If
            If (Not IsNull("Address")) Then
                objInfo.Address = Convert.ToString(getValue("Address"))
            End If
            If (Not IsNull("City")) Then
                objInfo.City = Convert.ToString(getValue("City"))
            End If
            If (Not IsNull("Attrib_Region")) Then
                objInfo.Attrib_Region = Convert.ToString(getValue("Attrib_Region"))
            End If
            If (Not IsNull("PostalCode")) Then
                objInfo.PostalCode = Convert.ToString(getValue("PostalCode"))
            End If
            If (Not IsNull("Country")) Then
                objInfo.Country = Convert.ToString(getValue("Country"))
            End If
            If (Not IsNull("Phone")) Then
                objInfo.Phone = Convert.ToString(getValue("Phone"))
            End If
            If (Not IsNull("Fax")) Then
                objInfo.Fax = Convert.ToString(getValue("Fax"))
            End If

        End Function

        Private Function ReadPersistentObject(ByVal objInfo As Customers)

            AddCmdParameter("@CompanyName", TDevFramework.EDataType.eVarchar, objInfo.CompanyName, TDevFramework.EParamDirection.eInput, objInfo.IsNull("CompanyName"))
            AddCmdParameter("@ContactName", TDevFramework.EDataType.eVarchar, objInfo.ContactName, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ContactName"))
            AddCmdParameter("@ContactTitle", TDevFramework.EDataType.eVarchar, objInfo.ContactTitle, TDevFramework.EParamDirection.eInput, objInfo.IsNull("ContactTitle"))
            AddCmdParameter("@Address", TDevFramework.EDataType.eVarchar, objInfo.Address, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Address"))
            AddCmdParameter("@City", TDevFramework.EDataType.eVarchar, objInfo.City, TDevFramework.EParamDirection.eInput, objInfo.IsNull("City"))
            AddCmdParameter("@Attrib_Region", TDevFramework.EDataType.eVarchar, objInfo.Attrib_Region, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Attrib_Region"))
            AddCmdParameter("@PostalCode", TDevFramework.EDataType.eVarchar, objInfo.PostalCode, TDevFramework.EParamDirection.eInput, objInfo.IsNull("PostalCode"))
            AddCmdParameter("@Country", TDevFramework.EDataType.eVarchar, objInfo.Country, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Country"))
            AddCmdParameter("@Phone", TDevFramework.EDataType.eVarchar, objInfo.Phone, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Phone"))
            AddCmdParameter("@Fax", TDevFramework.EDataType.eVarchar, objInfo.Fax, TDevFramework.EParamDirection.eInput, objInfo.IsNull("Fax"))

        End Function


        Private Function CheckPrimaryKeyValues(ByVal objInfo As Customers) As Boolean
            If ((objInfo("CustomerID").Null)) Then
                Throw New Exception("Primary key must have some valid value.")
            End If
            Return True

        End Function

#End Region

#Region "LoadChildren Methods"

        Public Function LoadChildren(ByRef objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
            LoadOrders(objInfo, nDepth, bCacheEnable)
        End Function


        Public Function LoadOrders(ByRef objInfo As Customers, ByVal nDepth As Int32, ByVal bCacheEnable As Boolean)
            Try

                Dim _OrdersFactory As OrdersFactory = New OrdersFactory(getConnection())
                objInfo.Orders = _OrdersFactory.FindByCustomers(objInfo.CustomerID, bCacheEnable)
                If (nDepth <> 0) Then
                    Dim OrdersOrdersInfo As Orders
                    For Each OrdersOrdersInfo In objInfo.Orders
                        _OrdersFactory.LoadChildren(OrdersOrdersInfo, nDepth - 1, bCacheEnable)
                    Next
                End If
                SetStatus(EStatus.eSuccess)

            Catch e As RecordNotFoundException
                SetStatus(EStatus.eFail)
                'ignore exception
            Catch e As Exception
                SetStatus(EStatus.eFail)
                Throw e
            End Try
        End Function

#End Region

    End Class
End Namespace
